Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 539680 - media-plugins/alsa-plugins-1.0.28 - .libs/rate_lavcrate.o: In function `pcm_src_free': .../work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:70: undefined reference to `av_resample_close'
Summary: media-plugins/alsa-plugins-1.0.28 - .libs/rate_lavcrate.o: In function `pcm_s...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] Library (show other bugs)
Hardware: All Linux
: Normal normal with 2 votes (vote)
Assignee: Gentoo ALSA team
URL:
Whiteboard:
Keywords:
: 539854 (view as bug list)
Depends on:
Blocks:
 
Reported: 2015-02-10 21:18 UTC by Daniel Schulte
Modified: 2015-04-06 19:19 UTC (History)
22 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
build.log (build.log,39.50 KB, text/plain)
2015-02-10 21:18 UTC, Daniel Schulte
Details
output of emerge --info '=media-plugins/alsa-plugins-1.0.28::gentoo' (file_539680.txt,6.69 KB, text/plain)
2015-02-10 21:19 UTC, Daniel Schulte
Details
Output of emerge -pqv '=media-plugins/alsa-plugins-1.0.28::gentoo' (file_539680.txt,192 bytes, text/plain)
2015-02-10 21:20 UTC, Daniel Schulte
Details
alsa-plugins-1.0.28-libav10.patch (alsa-plugins-1.0.28-libav10.patch,9.84 KB, patch)
2015-03-13 20:07 UTC, Russell Knighton
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Daniel Schulte 2015-02-10 21:18:41 UTC
Created attachment 396138 [details]
build.log

Google says av_resample_* has to do with libav. The most recent libav update might be the culprit here...
Comment 1 Daniel Schulte 2015-02-10 21:19:39 UTC
Created attachment 396140 [details]
output of emerge --info '=media-plugins/alsa-plugins-1.0.28::gentoo'
Comment 2 Daniel Schulte 2015-02-10 21:20:40 UTC
Created attachment 396142 [details]
Output of emerge -pqv '=media-plugins/alsa-plugins-1.0.28::gentoo'
Comment 3 N. Andrew Walsh 2015-02-11 16:37:05 UTC
There are several other undefined references that I imagine are due to a similar problem:

.libs/rate_lavcrate.o: In function `pcm_src_free':
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:70: undefined reference to `av_resample_close'
.libs/rate_lavcrate.o: In function `pcm_src_init':
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:96: undefined reference to `av_resample_init'
.libs/rate_lavcrate.o: In function `pcm_src_convert_s16':
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:186: undefined reference to `av_resample'
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:194: undefined reference to `av_resample_compensate'
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:194: undefined reference to `av_resample_compensate'
Comment 4 Jeroen Roovers (RETIRED) gentoo-dev 2015-02-13 08:29:16 UTC
*** Bug 539854 has been marked as a duplicate of this bug. ***
Comment 5 Leonardo Amaral 2015-02-19 02:25:34 UTC
Also here:

make[2]: Entering directory '/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28-abi_x86_64.amd64/rate-lavc'
/bin/sh ../libtool  --tag=CC   --mode=compile x86_64-pc-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/als
a-plugins-1.0.28/rate-lavc -I..   -DNDEBUG -Wall -g -I/usr/include/alsa -DAVCODEC_HEADER="<libavcodec/avcodec.h>" -O2 -pipe -march=native -c -o rate_la
vcrate.lo /var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c
libtool: compile:  x86_64-pc-linux-gnu-gcc -DHAVE_CONFIG_H -I. -I/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc 
-I.. -DNDEBUG -Wall -g -I/usr/include/alsa "-DAVCODEC_HEADER=<libavcodec/avcodec.h>" -O2 -pipe -march=native -c /var/tmp/portage/media-plugins/alsa-plu
gins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c  -fPIC -DPIC -o .libs/rate_lavcrate.o
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c: In function ‘pcm_src_free’:
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:70:3: warning: implicit declaration of function ‘
av_resample_close’ [-Wimplicit-function-declaration]
   av_resample_close(rate->context);
   ^
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c: In function ‘pcm_src_init’:
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:96:3: warning: implicit declaration of function ‘
av_resample_init’ [-Wimplicit-function-declaration]
   rate->context = av_resample_init(info->out.rate, info->in.rate,
   ^
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:96:17: warning: assignment makes pointer from integer without a cast [enabled by default]
   rate->context = av_resample_init(info->out.rate, info->in.rate,
                 ^
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c: In function ‘pcm_src_convert_s16’:
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:186:3: warning: implicit declaration of function ‘av_resample’ [-Wimplicit-function-declaration]
   ret = av_resample(rate->context, rate->out[i],
   ^
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:194:2: warning: implicit declaration of function ‘av_resample_compensate’ [-Wimplicit-function-declaration]
  av_resample_compensate(rate->context,
  ^
/bin/sh ../libtool  --tag=CC   --mode=link x86_64-pc-linux-gnu-gcc -Wall -g -I/usr/include/alsa -DAVCODEC_HEADER="<libavcodec/avcodec.h>" -O2 -pipe -march=native -module -avoid-version -export-dynamic -no-undefined -Wl,--no-undefined -Wl,-O1 -Wl,--as-needed -o libasound_module_rate_lavcrate.la -rpath /usr/lib64/alsa-lib rate_lavcrate.lo -lasound  -lavcodec -lavutil  -lasound
libtool: link: x86_64-pc-linux-gnu-gcc -shared  -fPIC -DPIC  .libs/rate_lavcrate.o   -lavcodec -lavutil -lasound  -g -O2 -march=native -Wl,--no-undefined -Wl,-O1 -Wl,--as-needed   -Wl,-soname -Wl,libasound_module_rate_lavcrate.so -o .libs/libasound_module_rate_lavcrate.so
.libs/rate_lavcrate.o: In function `pcm_src_free':
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:70: undefined reference to `av_resample_close'
.libs/rate_lavcrate.o: In function `pcm_src_init':
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:96: undefined reference to `av_resample_init'
.libs/rate_lavcrate.o: In function `pcm_src_convert_s16':
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:186: undefined reference to `av_resample'
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:194: undefined reference to `av_resample_compensate'
/var/tmp/portage/media-plugins/alsa-plugins-1.0.28/work/alsa-plugins-1.0.28/rate-lavc/rate_lavcrate.c:194: undefined reference to `av_resample_compensate'
collect2: error: ld returned 1 exit status
Makefile:412: recipe for target 'libasound_module_rate_lavcrate.la' failed
make[2]: *** [libasound_module_rate_lavcrate.la] Error 1

Just for record:

dora ~ # emerge -pav libav alsa-plugins

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild   R   *] media-video/libav-9999:0/10::gentoo  USE="X aac alsa amr bzip2 encode faac fdk fontconfig gpl gsm hardcoded-tables jpeg2k mp3 network openssl pulseaudio rtmp schroedinger sdl speex ssl theora threads tools truetype v4l vaapi vdpau vorbis vpx webp x264 x265 xvid zlib (-altivec) -bindist -cdio -cpudetection -custom-cflags -debug -doc -frei0r -ieee1394 -jack (-neon) -opus -oss -pic -static-libs {-test} (-vis) -wavpack" ABI_X86="(64) -32 (-x32)" CPU_FLAGS_X86="avx avx2 mmx mmxext ssse3 -3dnow -3dnowext" 0 KiB
[ebuild   R    ] media-plugins/alsa-plugins-1.0.28::gentoo  USE="ffmpeg pulseaudio speex* -debug -jack -libsamplerate" ABI_X86="(64) -32 (-x32)" 0 KiB

Total: 2 packages (2 reinstalls), Size of downloads: 0 KiB
Comment 6 Matt Turner gentoo-dev 2015-02-22 07:16:18 UTC
I'm using libav-11.2. Presumably alsa-plugins-1.0.28 isn't compatible with that.
Comment 7 Mike Auty (RETIRED) gentoo-dev 2015-02-22 11:46:22 UTC
Yep, it's also incompatible with libav-11.2.
Comment 8 Raimar Sandner 2015-02-25 15:05:40 UTC
With USE=-ffmpeg it compiles... For me sound seems to play just fine without it (pulseaudio/alsa).
Comment 9 John Moe 2015-02-27 08:11:49 UTC
FWIW, I get this same error for media-plugins/alsa-plugins as well as media-video/mplayer.
Comment 12 Alan Hourihane 2015-03-06 11:07:36 UTC
still an issue today.
Comment 13 Russell Knighton 2015-03-13 20:07:30 UTC
Created attachment 398818 [details, diff]
alsa-plugins-1.0.28-libav10.patch

I believe this may be the patch we're after - I lifted it from the Debian archive, but I believe it is/was based off of the one in this libav bug report: https://bugzilla.libav.org/show_bug.cgi?id=619

Applied on my systems and it seems to work okay so far, or at least it has cleanly compiled for me for the first time in a while.
Comment 14 Mathew Artemenko 2015-03-18 23:10:00 UTC
Applying the patch has fixed this issue for me.
Comment 15 Tony Vroon gentoo-dev 2015-03-25 12:12:45 UTC
My apologies, I committed 1.0.29 of alsa-plugins without looking at this bug first. I presume your patch is still required? (From looking at what has been linked, there has been no upstream change)
Comment 16 Lorenzo Porta (Vindex17) 2015-03-25 13:53:35 UTC
I confirm that the version bump has not fixed this bug unfortunately
Comment 17 Sergei Trofimovich (RETIRED) gentoo-dev 2015-04-06 19:19:41 UTC
Fails to build for me for quite a while with the same problems.

Pushed Luca's patch as:
>  06 Apr 2015; Sergei Trofimovich <slyfox@gentoo.org>
>  +files/alsa-plugins-1.0.28-libav10.patch, alsa-plugins-1.0.29.ebuild:
>  Applied libav-10 patch from bug #539680 by Daniel Schulte and others. Fixes
>  build failure for me.

Thanks!